﻿@using Jumbula.Web.Infrastructure.DataMigration
@model Jumbula.Web.Infrastructure.DataMigration.DataManipulationRunViewModel
@{
    var title = Model.Title;

    ViewBag.Title = title;
    ViewBag.Id = Model.Id;
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<div class="row padding-top20">
    <div class="col-md-6 col-md-offset-3">
        @using (Html.BeginForm("Upload", "DataManipulation", null, FormMethod.Post, new { enctype = "multipart/form-data" }))
        {
            <div>
                <div class="row">
                    <div class="col-md-3 pull-left">
                        <input type="file" name="FileUpload" />
                    </div>

                    <div class="col-md-3 pull-right">
                        <input class="pull-right btn btn-default" type="submit" name="Submit" id="Submit" value="Upload" />
                    </div>
                </div>
            </div>
        }
    </div>
</div>

<div class="row">
    <div class="col-md-6 col-md-offset-3">

        <h2>@title</h2>

        <hr />

        <div style="margin-bottom:30px" class="clearfix"></div>

        <fieldset>
            @if (Model.ResultItems != null)
            {
                <legend>Result history</legend>


                @Html.Partial("_ListResult", Model.ResultItems)
            }

        </fieldset>

        <div class="clearfix"></div>

        <fieldset>
            <legend></legend>
            @if (Model.PageMode == RunPageMode.Run)
            {

                //using (Html.BeginForm(actionName: "RunNew", controllerName: "DataMigration", method: FormMethod.Post, htmlAttributes: new { @id = "runForm" }))
                //{
                <input type="hidden" name="id" value="@Model.Id" />
                <input type="hidden" name="name" id="name" value="@Model.Name" />

                <div class="row">
                    <div class="col-md-6 col-md-offset-4">
                        <input class="btn btn-success" type="button" name="Submit" id="Run" value="Run Migration" />
                    </div>
                </div>
                //}

                <div class="clearfix"></div>
            }

            @if (Model.PageMode == RunPageMode.Success)
            {
                <div class="row">
                    <div class="col-md-6 col-md-offset-4">
                        <span style="color: green; font-weight: bold">
                            Migration done successfully.
                        </span>
                        <div class="clearfix"></div>
                        <a class="btn btn-success" href="@Url.Action("Index")">Back to migrations</a>
                    </div>
                </div>
            }

            @if (Model.PageMode == RunPageMode.Fail)
            {
                <div class="row">
                    <div class="col-md-6 col-md-offset-4">
                        <span style="color: red; font-weight: bold">
                            Migration failed.
                            <br />
                            @Model.Message
                        </span>
                        <div class="clearfix"></div>
                        <a class="btn btn-success" href="@Url.Action("Run", new { pageMode =  RunPageMode.Run })">Run again</a>
                    </div>
                </div>
            }
        </fieldset>

        <div class="clearfix"></div>

        <div class="form-group margin-top50">
            <div class="col-md-2"></div>

            <div class="col-md-6">
                <div id="message">

                </div>
            </div>
        </div>

        <div class="form-group margin-top50">
            <div class="col-md-2"></div>

            <div id="loading" style="display: none">
                <img src="~/Images/loading.gif" />
            </div>
        </div>
    </div>
</div>

@section Scripts{

    <script>
        $(document).ready(function () {
            $('#Run').click(function (e) {
                e.preventDefault();

                clearAllMessages();
                showLoading();
                run(null, null);
            })
        })

        var run = function (from) {

            var url = '@Url.Action("RunManipulation")';
            url += '?id=@Model.Id';

            var startPoint = parseInt('@Model.StartPoint');

            if (from != null) {
                startPoint = from;
            }
            else {
                manipulateMessage('Operation started...');
            }

            url += '&from=' + startPoint + '&endPoint=' + '@Model.EndPoint';

            url = encodeURI(url);

            $.ajax({
                type: "POST",
                url: url,
                //data: data,
                success: function (result) {
                    if (result.HasError) {
                        manipulateMessage(result.Message, 'error', buildReportLink());
                    }
                    {
                        if (result.Status == 0) {
                            manipulateMessage(result.Message, 'success', buildReportLink(result.Token));
                            run(result.ContinueFrom)
                        }
                        else if (result.Status == 1) {
                            manipulateMessage(result.Message, 'success', buildReportLink(result.Token));
                            allDone();
                        }
                        else {

                            manipulateMessage(result.Message, 'error', buildReportLink());
                        }
                    }
                }, error: function (result) {

                    manipulateMessage('Error in data manipulation.', 'error');

                    error();
                },
                //dataType: dataType
            });
        }

        var buildReportLink = function (token) {

            var result = '/DataManipulation/RunReport?id=@Model.Id'

            if (token != 'undefined' && token != null) {
                result += '&token=' + token;
            }

            result = encodeURI(result);

            return result;
        }

        var manipulateMessage = function (text, mode, link) {

            var message = '';
            var htmlLink = '';

            if (link != '' && link != null) {
                htmlLink = ' <a target="_blank" href="' + link + '">Details</a>'
            }

            if (mode == 'error') {
                message = '<p class="alert-danger">' + text + ' ' + htmlLink + '</p>';
                hideLoading();
            }
            else {
                message = '<p class="success">' + text + ' ' + htmlLink + '</p>';
            }

            $("#message").append(message);
        }

        var error = function (message) {

            hideLoading();

            if (message == '' || message == null) {
                message = 'Some thing went wrong.';
            }

            manipulateMessage(message, 'error');
        }

        var clearAllMessages = function () {
            $("#message").html('');
        }

        var allDone = function () {

            hideLoading();

            manipulateMessage('All proccesses done successfully.');

            hideLoading();
        }

        var showLoading = function () {
            $("#loading").show();
        }

        var hideLoading = function () {
            $("#loading").hide();
        }
    </script>
}
